<?php
if(!defined('BASEPATH')){
	define('BASEPATH', dirname(__FILE__) . '/');
}
require(BASEPATH . 'configs/config.php');
require(BASEPATH . 'configs/servers.php');

require(BASEPATH . 'system/libs/logger.php');


function system_message($message, $level='error'){
	$logger = new logger();
	$logger->log($message, $level);
}

$logger = new logger();

# ============================================================
# Global system object
class global_system_object {
	
}

class global_system_loader {
	function database($config = null){
		global $GSO;
		
		require(BASEPATH . 'system/libs/db.php');
		require(BASEPATH . 'configs/db.php');
		$GSO->db = new db;
		$GSO->db->connect($config['database']);
	}
	function model($name){
		
	}
}

global $GSO;
$GSO = new global_system_object();
$GSO->load = new global_system_loader();

# ============================================================
# Load Database
$GSO->load->database();
$db = $GSO->db; # Alias, Todo: use global object for queries


class system_model {
	/*function __call($method, $args) {
		echo 'test';
		
		global $GSO;
		$this->$method = $GSO->$method;
		call_user_func_array();
    }*/
	
	public function __get($name)
    {
		global $GSO;
		if(isset($GSO->$name)){
			return $GSO->$name;
		}
		
        echo "Getting '$name'\n";

        $trace = debug_backtrace();
        trigger_error(
            'Undefined property via __get(): ' . $name .
            ' in ' . $trace[0]['file'] .
            ' on line ' . $trace[0]['line'],
            E_USER_NOTICE);
        return null;
    }

}

