<?php
class dataset_maps extends dataset {
	public $url_segment_map = array(
		'server_id',
		'date',
	);
	
	function get(){
		$return = array();
		
		# Maps
		$sql = "SELECT *
			FROM server_maps 
			WHERE server_id=" . (int)$this->dataset['server']['id'] . "
			ORDER BY map ASC
		";

		$return['maps'] = array();
		$mapindexes = array();
		foreach($this->db->query($sql) as $row){
			$return['maps'][] = $row;
			$mapindexes[] = $row['map'];
		}

		# Player Spawn Locations
		$sql = "SELECT datetime, user_name AS name, message AS coords
			FROM log_activity 
			WHERE server_id=" . (int)$this->dataset['server']['id'] . "
				AND activity IN ('coords')
				AND datetime BETWEEN '" . $this->filters['date_from'] . "' AND '" . $this->filters['date_stop'] . "'
			ORDER BY datetime ASC
		";

		foreach($this->db->query($sql) as $row){
			$row['datetime'] = encode_datetime($row['datetime']);
			if(substr($row['coords'], 0, 1)=='{' || substr($row['coords'], 0, 1)=='['){
				$row['coords'] = json_decode($row['coords'], true);
			} else {
				$row['coords'] = array();
			}
			
			if(isset($row['coords']['dimension'])){
				$mapindex = array_search($row['coords']['dimension'], $mapindexes);
				$return['maps'][$mapindex]['locations'][] = $row;
			} else {
				$return['maps']['x']['locations'][] = $row;
			}
		}
		
		#Return
		$return['filters']['date']	= array(
									'from'	=> date('c' , $this->filters['date_from_unix']),
									'stop'	=> date('c' , $this->filters['date_stop_unix']),
								);
		
		return $return;
	}
}
