<?php
class dataset_server extends dataset {
	function get(){
		$return = array();
		
		$fields = array(
			'banned-ips'		=> 'user_name, date1, value1, value2, value3',
			'banned-players'	=> 'user_name, date1, value1, value2, value3, value4',
			'ops' 				=> 'user_name, value1',
			#'usercache' 		=> '',
			'whitelist'			=> 'user_name'
		);

		$meta = preg_replace('/[^A-z0-9_-]+/is', '', $this->filters[1]);
		if(!in_array($meta, array_keys($fields))){
			$this->dataset['errors'][] = 'Invalid data set "' . $meta . '"';
			return $this->dataset;
		}

		# List Logs
		$sql = "SELECT " . $fields[$meta] . "
			FROM player_meta
			WHERE server_id=" . (int)$this->dataset['server']['id'] . "
				AND meta='" . $meta . "'
			ORDER BY date1 DESC
		";

		$return['rows'] = array();
		foreach($this->db->query($sql) as $row){
			$return['rows'][] = $row;
		}

		#Return
		return $return;
	}
}
